/*++

Copyright (c) 2009
Lysann Kessler, Stephanie Platz, Thomas Klingbeil, Philipp Tessenow, Frank Schlegel;
Michael Haupt, Michael Perscheid, Robert Hirschfeld;
Software Architecture Group, Hasso-Plattner-Institut, University of Potsdam, Germany

This software is published under MIT license.
It uses phidget library by Phidgets Inc. (http://phidgets.com).
See ../../../../license.pdf for more information.

--*/

#ifndef _PHIDGETRFID_H_
#define _PHIDGETRFID_H_

typedef struct _PhidgetRFID PhidgetRFID;

#include "PhidgetPlugin.h"

//
// Special Phidget-struct for an RFID Phidget. Additionally contains semaphores
// concerning outputs and finding/losing tags.
//

struct _PhidgetRFID {
	CPhidgetRFIDHandle handle;			// handle provided by phidget21 library upon creation
	PhidgetId id;						// timestamp of object creation to provide unique identifier
	CPhidget_DeviceClass deviceClass;	// the Phidget's type
	Phidget* pNextLink;					// pointer to next Phidget in the Plugin's global Phidgets list
	int iSemaphoreAttach;				// semaphore index for RFID attachment
	int iSemaphoreDetach;				// semaphore index for RFID detachment
	int iSemaphoreError;				// semaphore index for errors in Phidgets
	int	iSemaphoreOutputChange;			// semaphore index to signal when a digital output changed
	int iSemaphoreTagFound;				// semaphore index to signal when a tag was found
	int iSemaphoreTagLost;				// semaphore index to signal when a tag was lost
};

// methods
PhidgetId phidgetRFID_GetNewId();
void phidgetRFID_ResetSemaphores(PhidgetRFID *pPhidget);
BOOL phidgetRFID_Open(PhidgetRFID *pPhidget);
BOOL phidgetRFID_Close(PhidgetRFID *pPhidget);

#endif // _PHIDGETRFID_H_
