/*++

Copyright (c) 2009
Lysann Kessler, Stephanie Platz, Thomas Klingbeil, Philipp Tessenow, Frank Schlegel;
Michael Haupt, Michael Perscheid, Robert Hirschfeld;
Software Architecture Group, Hasso-Plattner-Institut, University of Potsdam, Germany

This software is published under MIT license.
It uses phidget library by Phidgets Inc. (http://phidgets.com).
See ../../../../license.pdf for more information.

--*/

#ifndef _SIMPLE_LOG_H_
#define _SIMPLE_LOG_H_

// INCLUDES
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <xmutex.h>

// TYPES

typedef short SLOG_BOOL;
#define	SLOG_TRUE	1
#define	SLOG_FALSE	0

typedef enum _SLogLevel {
	SLOG_LEVEL_NOT_SET = 0,
	SLOG_LEVEL_VERBOSE,
	SLOG_LEVEL_INFO,
	SLOG_LEVEL_WARNING,
	SLOG_LEVEL_ERROR,
	SLOG_LEVEL_CRITICAL,
	SLOG_LEVEL_DEBUG,		// is only printed if DEBUG constant is set
} SLogLevel;

// FUCNTION PROTOTYPES

inline SLOG_BOOL SLog_enableLogging(const char* pcTargetFile, SLogLevel minLevel);
inline SLOG_BOOL SLog_enableLogging_ex(const char* pcTargetFile, const char* pcWriteMode, SLogLevel minLevel, SLOG_BOOL bDebugVersion, SLOG_BOOL bMutualExclusion);
inline SLOG_BOOL SLog_disableLogging();
inline SLOG_BOOL SLog(SLogLevel level, const char* pcMessage, ...);

#endif //_SIMPLE_LOG_H_
