# Makefile for Squeak Phidget Plugin
# ###################################
# Last edited: 2009-05-07 09:40 by lk

la				=.la

module-name		=PhidgetPlugin
module			=$(module-name)$(la)

configdir		=../config
builddir		=.
BUILDDIRNAME	=build

squeakdir		=/usr/local/lib/squeak/3.10-4

LIBTOOL			=$(builddir)/libtool
INSTALL			=/usr/bin/install -c

#####################################
# build rules

plugin : configure build install

debug : configure build-debug install

configure :
	mkdir -p $(BUILDDIRNAME)
	( cd $(BUILDDIRNAME); ../config/configure; )

build : configure
	$(MAKE) -C $(BUILDDIRNAME) $(MFLAGS) $(module)

build-debug : configure
	env DEBUG=1 $(MAKE) -C $(BUILDDIRNAME) $(MFLAGS) $(module)

install :
	cd $(BUILDDIRNAME); \
	$(LIBTOOL) --mode=install $(INSTALL) $(module-name)/$(module) $(squeakdir)/$(module); \
	$(LIBTOOL) --finish $(squeakdir); \
	rm $(squeakdir)/$(module);

uninstall :
	rm -f $(squeakdir)/$(module-name)

#####################################
# clean

clean :
	rm -rf $(BUILDDIRNAME)

uninstall-clean: clean uninstall
