/*++

Copyright (c) 2009
Lysann Kessler, Stephanie Platz, Thomas Klingbeil, Philipp Tessenow, Frank Schlegel;
Michael Haupt, Michael Perscheid, Robert Hirschfeld;
Software Architecture Group, Hasso-Plattner-Institut, University of Potsdam, Germany

This software is published under MIT license.
It uses phidget library by Phidgets Inc. (http://phidgets.com).
See ../../../../license.pdf for more information.

--*/

#ifndef _PHIDGETADVANCEDSERVO_H_
#define _PHIDGETADVANCEDSERVO_H_

typedef struct _PhidgetAdvServo PhidgetAdvServo;

#include "PhidgetPlugin.h"

//
// Special Phidget-struct for an MotorControl. Additionally contains semaphores
// concerning position, current draw and the change of velocity
//

struct _PhidgetAdvServo {
	CPhidgetAdvancedServoHandle handle;	// handle provided by phidget21 library upon creation
	PhidgetId id;						// timestamp of object creation to provide unique identifier
	CPhidget_DeviceClass deviceClass;	// the Phidget's type
	Phidget* pNextLink;					// pointer to next Phidget in the Plugin's global Phidgets list
	int	iSemaphoreAttach;				// semaphore index for Advanced Servo attachment
	int iSemaphoreDetach;				// semaphore index for Advanced Servo detachment
	int iSemaphoreError;				// semaphore index for errors in Phidgets
	int	iSemaphoreVelocityChange;		// semaphore index for a change of the velocity of a motor
	int iSemaphoreCurrentChange;		// semaphore index for a change of the current draw of a motor
	int iSemaphorePositionChange;		// semaphore index for a change of position of a motor
};

// functions
sqInt phidgetAdvServo_Create();
void phidgetAdvServo_ResetSemaphores(PhidgetAdvServo* pPhidget);
BOOL phidgetAdvServo_Close(PhidgetAdvServo* pPhidget);
BOOL phidgetAdvServo_Open(PhidgetAdvServo* pPhidget);

#endif //_PHIDGETADVANCEDSERVO_H_
