/*++

Copyright (c) 2009
Lysann Kessler, Stephanie Platz, Thomas Klingbeil, Philipp Tessenow, Frank Schlegel;
Michael Haupt, Michael Perscheid, Robert Hirschfeld;
Software Architecture Group, Hasso-Plattner-Institut, University of Potsdam, Germany

This software is published under MIT license.
It uses phidget library by Phidgets Inc. (http://phidgets.com).
See ../../../../license.pdf for more information.

--*/

#ifndef _PHIDGETINTERFACEKIT_H_
#define _PHIDGETINTERFACEKIT_H_

typedef struct _PhidgetIfKit PhidgetIfKit;

#include "PhidgetPlugin.h"

//
// Special Phidget-struct for an InterfaceKit. Additionally contains semaphores
// concerning sensors and I/O.
//

struct _PhidgetIfKit {
	CPhidgetInterfaceKitHandle handle;	// handle provided by phidget21 library upon creation
	PhidgetId id;						// timestamp of object creation to provide unique identifier
	CPhidget_DeviceClass deviceClass;	// the Phidget's type
	Phidget* pNextLink;					// pointer to next Phidget in the Plugin's global Phidgets list
	int	iSemaphoreAttach;				// semaphore index for Inferface Kit attachment
	int iSemaphoreDetach;				// semaphore index for Interface Kit detachment
	int iSemaphoreError;				// semaphore index for errors in Phidgets
	int	iSemaphoreSensorChange;			// semaphore index for a change of an analog sensor
	int	iSemaphoreInputChange;			// semaphore to signal when a digital input changed
	int	iSemaphoreOutputChange;			// semaphore to signal when a digital output changed
};

// methods
sqInt phidgetIfKit_Create();
void phidgetIfKit_ResetSemaphores(PhidgetIfKit *pPhidget);
int phidgetIfKit_Open(PhidgetIfKit* pPhidget);
int phidgetIfKit_Close(PhidgetIfKit* pPhidget);

#endif //_PHIDGETINTERFACEKIT_H_
