/*++

Copyright (c) 2009
Lysann Kessler, Stephanie Platz, Thomas Klingbeil, Philipp Tessenow, Frank Schlegel;
Michael Haupt, Michael Perscheid, Robert Hirschfeld;
Software Architecture Group, Hasso-Plattner-Institut, University of Potsdam, Germany

This software is published under MIT license.
It uses phidget library by Phidgets Inc. (http://phidgets.com).
See ../../../../license.pdf for more information.

--*/

#ifndef _PHIDGETMANAGER_H_
#define _PHIDGETMANAGER_H_

#include "PhidgetPlugin.h"

//////////////////////////////////////////////////////////////////////////
// Global variables declaration

extern CPhidgetManagerHandle g_phidgetManager;

//////////////////////////////////////////////////////////////////////////
// Function declarations

BOOL phidgetManager_initialise();
BOOL phidgetManager_shutDown();

BOOL phidgetManager_SetSemaphoreIndex_Attach(int iSemaphore);
BOOL phidgetManager_SetSemaphoreIndex_Detach(int iSemaphore);
BOOL phidgetManager_SetSemaphoreIndex_Error(int iSemaphore);

int phidgetManager_getNumberOfAttachedDevices();
BOOL phidgetManager_getAttachedDeviceName(int iIndex, const char** ppcName, int* piNameSize);
BOOL phidgetManager_getAttachedDeviceSerialNumber(int iIndex, int* piSerialNumber);
BOOL phidgetManager_getAttachedDeviceLabel(int iIndex, const char** ppcLabel, int* piLabelSize);
BOOL phidgetManager_getAttachedDeviceClass(int iIndex, CPhidget_DeviceClass* pClass);
BOOL phidgetManager_getAttachedDeviceType(int iIndex, CPhidget_DeviceID* pDeviceID);


#endif //_PHIDGETMANAGER_H_
