/*++

Copyright (c) 2009
Lysann Kessler, Stephanie Platz, Thomas Klingbeil, Philipp Tessenow, Frank Schlegel;
Michael Haupt, Michael Perscheid, Robert Hirschfeld;
Software Architecture Group, Hasso-Plattner-Institut, University of Potsdam, Germany

This software is published under MIT license.
It uses phidget library by Phidgets Inc. (http://phidgets.com).
See ../../../../license.pdf for more information.

--*/

#ifndef _PHIDGETSERVO_H_
#define _PHIDGETSERVO_H_

typedef struct _PhidgetServo PhidgetServo;

#include "PhidgetPlugin.h"

//
// Special Phidget-struct for an Servo. Additionally contains a semaphore
// concerning the change of position.
//

struct _PhidgetServo {
	CPhidgetServoHandle handle;			// handle provided by phidget21 library upon creation
	PhidgetId id;						// timestamp of object creation to provide unique identifier
	CPhidget_DeviceClass deviceClass;	// the Phidget's type
	Phidget* pNextLink;					// pointer to next Phidget in the Plugin's global Phidgets list
	int	iSemaphoreAttach;				// semaphore index for Servo attachment
	int iSemaphoreDetach;				// semaphore index for Servo detachment
	int iSemaphoreError;				// semaphore index for errors in Phidgets
	int iSemaphorePositionChange;		// semaphore index for a change of position
};

// methods
sqInt phidgetServo_Create();
void phidgetServo_ResetSemaphores(PhidgetServo *pPhidget);
int phidgetServo_Open(PhidgetServo* pPhidget);
int phidgetServo_Close(PhidgetServo* pPhidget);

#endif //_PHIDGETSERVO_H_
